## udev 0.125

=== Makefile ===
#
# Copyright (C) 2003-2004 Greg Kroah-Hartman <greg@kroah.com>
# Copyright (C) 2004-2006 Kay Sievers <kay.sievers@vrfy.org>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; version 2 of the License.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#

VERSION = 125

# set this to make use of syslog
USE_LOG = true

# compile-in development debug messages
# (export UDEV_LOG="debug" or set udev_log="debug" in udev.conf
#  to print the debug messages to syslog)
DEBUG = false

# compile with gcc's code coverage option
USE_GCOV = false

# include Security-Enhanced Linux support
USE_SELINUX = false

# set this to create statically linked binaries
USE_STATIC = false

# to build any of the extras programs pass:
#  make EXTRAS="extras/<extra1> extras/<extra2>"
EXTRAS =

# make the build silent
V =

PROGRAMS = \
	udevd				\
	udevadm				\
	test-udev

HEADERS = \
	udev.h				\
	udevd.h				\
	udev_rules.h			\
	logging.h			\
	udev_sysdeps.h			\
	udev_selinux.h			\
	list.h

UDEV_OBJS = \
	udev_device.o			\
	udev_config.o			\
	udev_node.o			\
	udev_db.o			\
	udev_sysfs.o			\
	udev_rules.o			\
	udev_rules_parse.o		\
	udev_utils.o			\
	udev_utils_string.o		\
	udev_utils_file.o		\
	udevmonitor.o			\
	udevinfo.o			\
	udevcontrol.o			\
	udevtrigger.o			\
	udevsettle.o			\
	udevtest.o			\
	udev_sysdeps.o
LIBUDEV = libudev.a

MAN_PAGES = \
	udev.7				\
	udevd.8				\
	udevadm.8

GEN_HEADERS = \
	udev_version.h

prefix ?=
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev
udevdir =	/dev
DESTDIR =

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}
PWD = $(shell pwd)

CROSS_COMPILE ?=
CC = $(CROSS_COMPILE)gcc
LD = $(CROSS_COMPILE)gcc
AR = $(CROSS_COMPILE)ar
RANLIB = $(CROSS_COMPILE)ranlib

CFLAGS		+= -g -Wall -pipe -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
WARNINGS	= -Wstrict-prototypes -Wsign-compare -Wshadow \
		  -Wchar-subscripts -Wmissing-declarations -Wnested-externs \
		  -Wpointer-arith -Wcast-align -Wsign-compare -Wmissing-prototypes
CFLAGS		+= $(WARNINGS)

LDFLAGS += -Wl,-warn-common,--as-needed

OPTFLAGS = -Os
CFLAGS += $(OPTFLAGS)

ifeq ($(strip $(USE_LOG)),true)
	CFLAGS += -DUSE_LOG
endif

# if DEBUG is enabled, then we do not strip
ifeq ($(strip $(DEBUG)),true)
	CFLAGS  += -DDEBUG
endif

ifeq ($(strip $(USE_GCOV)),true)
	CFLAGS += -fprofile-arcs -ftest-coverage
	LDFLAGS += -fprofile-arcs
endif

ifeq ($(strip $(USE_SELINUX)),true)
	UDEV_OBJS += udev_selinux.o
	LIB_OBJS += -lselinux -lsepol
	CFLAGS += -DUSE_SELINUX
endif

ifeq ($(strip $(USE_STATIC)),true)
	CFLAGS += -DUSE_STATIC
	LDFLAGS += -static
endif

ifeq ($(strip $(V)),)
	E = @echo
	Q = @
else
	E = @\#
	Q =
endif
export E Q

all: $(PROGRAMS) $(MAN_PAGES)
	$(Q) extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) CC="$(CC)" \
			CFLAGS="$(CFLAGS)" \
			LD="$(LD)" \
			LDFLAGS="$(LDFLAGS)" \
			AR="$(AR)" \
			RANLIB="$(RANLIB)" \
			LIB_OBJS="$(LIB_OBJS)" \
			LIBUDEV="$(PWD)/$(LIBUDEV)" \
			-C $$target $@ || exit 1; \
	done;
.PHONY: all
.DEFAULT: all

# clear implicit rules
.SUFFIXES:

# build the objects
%.o: %.c $(HEADERS) $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

# "Static Pattern Rule" to build all programs
$(PROGRAMS): %: $(HEADERS) $(GEN_HEADERS) $(LIBUDEV) %.o
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o -o $@ $(LIBUDEV) $(LIB_OBJS)

$(LIBUDEV): $(HEADERS) $(GEN_HEADERS) $(UDEV_OBJS)
	$(Q) rm -f $@
	$(E) "  AR      " $@
	$(Q) $(AR) cq $@ $(UDEV_OBJS)
	$(E) "  RANLIB  " $@
	$(Q) $(RANLIB) $@

udev_version.h:
	$(E) "  GENHDR  " $@
	$(Q) echo "/* Generated by make. */" > $@
	$(Q) echo \#define UDEV_VERSION		\"$(VERSION)\" >> $@
	$(Q) echo \#define UDEV_CONFIG_FILE	\"$(configdir)/udev.conf\" >> $@

# man pages
%.8 %.7: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) - find . -type f -name '*.orig' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name '*.rej' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name '*~' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name '*.[oas]' -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name "*.gcno" -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name "*.gcda" -print0 | xargs -0r rm -f
	$(Q) - find . -type f -name "*.gcov" -print0 | xargs -0r rm -f
	$(Q) - rm -f udev_gcov.txt
	$(Q) - rm -f core $(PROGRAMS) $(GEN_HEADERS)
	$(Q) - rm -f udev-$(VERSION).tar.gz
	$(Q) - rm -f udev-$(VERSION).tar.bz2
	$(Q) - rm -f udev-git-HEAD.patch
	@ extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: clean

install-config:
	$(INSTALL) -d $(DESTDIR)$(libudevdir)/rules.d
	$(INSTALL) -d $(DESTDIR)$(configdir)/rules.d
	@ if [ ! -r $(DESTDIR)$(configdir)/udev.conf ]; then \
		$(INSTALL_DATA) udev.conf $(DESTDIR)$(configdir); \
	fi
	cp rules/rules.d/* $(DESTDIR)$(libudevdir)/rules.d
	@ extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: install-config

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man7
	$(INSTALL_DATA) udev.7 $(DESTDIR)$(mandir)/man7/udev.7
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) udevd.8 $(DESTDIR)$(mandir)/man8/udevd.8
	$(INSTALL_DATA) udevadm.8 $(DESTDIR)$(mandir)/man8/udevadm.8
	@extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: install-man

uninstall-man:
	- rm -f $(DESTDIR)$(mandir)/man7/udev.7
	- rm -f $(DESTDIR)$(mandir)/man8/udevadm.8
	- rm -f $(DESTDIR)$(mandir)/man8/udevd.8
	@ extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: uninstall-man

install-bin:
	$(INSTALL) -d $(DESTDIR)$(sbindir)
	$(INSTALL_PROGRAM) udevd $(DESTDIR)$(sbindir)/udevd
	$(INSTALL_PROGRAM) udevadm $(DESTDIR)$(sbindir)/udevadm
	ln -f -s udevadm $(DESTDIR)$(sbindir)/udevsettle
	$(INSTALL) -d $(DESTDIR)$(usrbindir)
	ln -f -s $(sbindir)/udevadm $(DESTDIR)$(usrbindir)/udevinfo
	@extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
ifndef DESTDIR
	- killall udevd
	- rm -rf $(udevdir)/.udev
	- $(sbindir)/udevd --daemon
endif
.PHONY: install-bin

uninstall-bin:
	- rm -f $(DESTDIR)$(sbindir)/udevd
	- rm -f $(DESTDIR)$(sbindir)/udevadm
	- rm -f $(DESTDIR)$(sbindir)/udevsettle
	- rm -f $(DESTDIR)$(usrbindir)/udevinfo
ifndef DESTDIR
	- killall udevd
	- rm -rf $(udevdir)/.udev
endif
	@extras="$(EXTRAS)"; for target in $$extras; do \
		$(MAKE) -C $$target $@ || exit 1; \
	done;
.PHONY: uninstall-bin

install: all install-bin install-config install-man
.PHONY: install

uninstall: uninstall-bin uninstall-man
.PHONY: uninstall

test tests: all
	@ cd test && ./udev-test.pl
.PHONY: test tests

buildtest:
	test/simple-build-check.sh
.PHONY: buildtest

ChangeLog:
	head -1 $@ | grep -q "to v$(shell echo $$(($(VERSION) - 1)))"
	@ mv $@ $@.tmp
	@ echo "Summary of changes from v$(shell echo $$(($(VERSION) - 1))) to v$(VERSION)" >> $@
	@ echo "============================================" >> $@
	@ echo >> $@
	@ git log --pretty=short $(shell echo $$(($(VERSION) - 1)))..HEAD | git shortlog  >> $@
	@ echo >> $@
	@ cat $@
	@ cat $@.tmp >> $@
	@ rm $@.tmp
	head -1 $@ | grep -q "to v$(VERSION)"
.PHONY: ChangeLog
.PRECIOUS: ChangeLog

release:
	$(Q) - rm -f udev-$(VERSION).tar.gz
	$(Q) - rm -f udev-$(VERSION).tar.bz2
	head -1 ChangeLog | grep -q "to v$(VERSION)"
	head -1 RELEASE-NOTES | grep -q "udev $(VERSION)"
	git commit -a -m "release $(VERSION)"
	cat .git/refs/heads/master > .git/refs/tags/$(VERSION)
	@ echo
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | gzip -9v > udev-$(VERSION).tar.gz
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | bzip2 -9v > udev-$(VERSION).tar.bz2
.PHONY: release

dist:
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | gzip -9v > udev-$(VERSION).tar.gz
	git-archive --format=tar --prefix=udev-$(VERSION)/ HEAD | bzip2 -9v > udev-$(VERSION).tar.bz2
.PHONY: dist

patch:
	git diff $(shell echo $$(($(VERSION) - 1))) HEAD > udev-git-HEAD.patch
.PHONY: patch

gcov-all:
	$(MAKE) clean all USE_GCOV=true
	@ echo
	@ echo "binaries built with gcov support."
	@ echo "run the tests and analyze with 'make udev_gcov.txt'"
.PHONY: gcov-all

# see docs/README-gcov_for_udev
udev_gcov.txt: $(wildcard *.gcda) $(wildcard *.gcno)
	for file in `find -maxdepth 1 -name "*.gcno"`; do \
		name=`basename $$file .gcno`; \
		echo "################" >> $@; \
		echo "$$name.c" >> $@; \
		echo "################" >> $@; \
		if [ -e "$$name.gcda" ]; then \
			gcov -l "$$name.c" >> $@ 2>&1; \
		else \
			echo "code for $$name.c was never executed" >> $@ 2>&1; \
		fi; \
		echo >> $@; \
	done; \
	echo "view $@ for the result"

=== extras/ata_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = ata_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) -D $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/cdrom_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = cdrom_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
	$(INSTALL) -d $(DESTDIR)$(libudevdir)/rules.d
	$(INSTALL_DATA) 60-cdrom_id.rules $(DESTDIR)$(libudevdir)/rules.d/60-cdrom_id.rules
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
	- rm $(DESTDIR)$(libudevdir)/rules.d/60-cdrom_id.rules
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/collect/Makefile ===
# Makefile for udev extra invoked by the udev main Makefile

PROG = collect
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: install-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/edd_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = edd_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
	$(INSTALL) -d $(DESTDIR)$(libudevdir)/rules.d/
	$(INSTALL_DATA) 61-persistent-storage-edd.rules $(DESTDIR)$(libudevdir)/rules.d/61-persistent-storage-edd.rules
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
	- rm $(DESTDIR)$(libudevdir)/rules.d/61-persistent-storage-edd.rules
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/firmware/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2006 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = firmware.sh
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_SCRIPT) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: install-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/floppy/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = create_floppy_devices
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8/
	$(INSTALL_DATA) $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/fstab_import/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2008 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = fstab_import
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL_PROGRAM) -D $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
	$(INSTALL_DATA) 79-fstab_import.rules $(DESTDIR)$(libudevdir)/rules.d/79-fstab_import.rules
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
	- rm $(DESTDIR)$(libudevdir)/rules.d/79-fstab_import.rules
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: install-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/path_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2006 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = path_id
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_SCRIPT) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8/
	$(INSTALL_DATA) $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/rule_generator/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2006 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_DATA) rule_generator.functions $(DESTDIR)$(libudevdir)/rule_generator.functions
	$(INSTALL_SCRIPT) write_cd_rules $(DESTDIR)$(libudevdir)/write_cd_rules
	$(INSTALL_SCRIPT) write_net_rules $(DESTDIR)$(libudevdir)/write_net_rules
	$(INSTALL) -d  $(DESTDIR)$(libudevdir)/rules.d
	$(INSTALL_DATA) 75-cd-aliases-generator.rules \
		$(DESTDIR)$(libudevdir)/rules.d/75-cd-aliases-generator.rules
	$(INSTALL_DATA) 75-persistent-net-generator.rules \
		$(DESTDIR)$(libudevdir)/rules.d/75-persistent-net-generator.rules
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/rule_generator.functions
	- rm $(DESTDIR)$(libudevdir)/write_cd_rules
	- rm $(DESTDIR)$(libudevdir)/write_net_rules
	- rm $(DESTDIR)$(configdir)/rules.d/75-cd-aliases-generator.rules
	- rm $(DESTDIR)$(configdir)/rules.d/75-persistent-net-generator.rules
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: install-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/scsi_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2003 IBM
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

SCSI_ID_VERSION = 2.0

PROG = scsi_id
OBJS= scsi_serial.o
HEADERS = scsi_id.h scsi.h scsi_id_version.h bsg.h
GEN_HEADERS = scsi_id_version.h
MAN_PAGES = scsi_id.8

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

scsi_id_version.h:
	$(E) "  GENHDR  " $@
	$(Q) echo "/* Generated by make. */" > $@
	$(Q) echo \#define SCSI_ID_VERSION     \"$(SCSI_ID_VERSION)\" >> $@
	$(Q) echo \#define SCSI_ID_CONFIG_FILE     \"$(etcdir)/scsi_id.config\" >> $@

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	$(INSTALL) -d $(DESTDIR)$(mandir)/man8
	$(INSTALL_DATA) scsi_id.8 $(DESTDIR)$(mandir)/man8/scsi_id.8
.PHONY: install-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/scsi_id.8
.PHONY: uninstall-man

install-config:
	@ if [ ! -r $(DESTDIR)$(etcdir)/scsi_id.config ]; then \
		echo $(INSTALL) -d $(DESTDIR)$(etcdir); \
		echo $(INSTALL_DATA) ./scsi_id.config  $(DESTDIR)$(etcdir); \
		$(INSTALL) -d $(DESTDIR)$(etcdir); \
		$(INSTALL_DATA) ./scsi_id.config $(DESTDIR)$(etcdir)/scsi_id.config; \
	fi
.PHONY: install-config

install: all install-bin install-config install-man
.PHONY: install

uninstall: uninstall-bin uninstall-man
.PHONY: uninstall

=== extras/usb_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = usb_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(E) "  CC      " $@
	$(Q) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(E) "  LD      " $@
	$(Q) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIB_OBJS)

# man pages
%.8: %.xml
	$(E) "  XMLTO   " $@
	$(Q) xmlto man $?
.PRECIOUS: %.8

clean:
	$(E) "  CLEAN   "
	$(Q) rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL) -d $(DESTDIR)$(libudevdir)
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: install-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

## udev 3.2.2+devuan2.11

=== debian/changelog ===
udev (1:3.2.2+devuan2.11) unstable; urgency=medium

  [Svante Signell]
  * debian/control: Exchange Maintainer and Uploaders names.

  [Hleb Valoshka]
  * debian/udev.maintscript: Fix upgrade to eudev by removing udev conffiles.

 -- Svante Signell <svante.signell@gmail.com>  Sat, 31 Mar 2018 11:56:00 +0100

udev (1:3.2.2+devuan2.10) unstable; urgency=medium

  * Prepare Ascii package

 -- Ivan J. <parazyd@dyne.org>  Wed, 06 Dec 2017 14:47:00 +0100

udev (1:3.2.2+devuan2.10) experimental; urgency=medium

  * control: Change binary packages to:
    udev: Architecture: linux-any, Multi_Ach: foreign
    libudev1: Architecture: linux-any, Multi_Ach: same
    libudev-dev: Architecture: linux-any, Multi_Ach: same

 -- Svante Signell <svante.signell@gmail.com>  Wed, 29 Nov 2017 16:25:23 +0100

udev (1:3.2.2+devuan2.9) experimental; urgency=medium

  * Make package almost lintian clean, rename to 1:3.2.2+devuan2.9,
    change format to native.

 -- Svante Signell <svante.signell@gmail.com>  Tue, 28 Nov 2017 18:16:23 +0100

udev (1:3.2.2-devuan2.9) experimental; urgency=medium

  * Switch Architecture back to All
  * Drop Multi-Arch

 -- Ivan J. <parazyd@dyne.org>  Sat, 25 Nov 2017 15:34:01 +0100

udev (1:3.2.2-devuan2.8) experimental; urgency=medium

  * Update with Hleb Valoshka's suggestions.

 -- Ivan J. <parazyd@dyne.org>  Sat, 25 Nov 2017 14:04:00 +0200

udev (1:3.2.2-devuan2.7) experimental; urgency=medium

  * Bump version to reflect eudev

 -- Ivan J. <parazyd@dyne.org>  Fri, 24 Nov 2017 11:56:00 +0100

udev (1:3.2.2-devuan2) experimental; urgency=medium

  * Initial transitional package commit.

 -- Ivan J. <parazyd@dyne.org>  Fri, 24 Nov 2017 11:20:00 +0100

=== debian/control ===
Source: udev
Section: oldlibs
Priority: extra
Maintainer: Svante Signell <svante.signell@gmail.com>
Uploaders: Ivan J. <parazyd@dyne.org>, Hleb Valoshka <375gnu@gmail.com>
Standards-Version: 3.9.8
Build-Depends: debhelper (>= 9)
Vcs-Git: https://git.devuan.org/devuan-packages/udev.git
Vcs-Browser: https://git.devuan.org/devuan-packages/udev.git

Package: udev
Depends: eudev, ${misc:Depends}
Architecture: linux-any
Multi-Arch: foreign
Description: Transitional package for eudev
 This is a transitional package to ease upgrades to the eudev package.
 It can safely be removed.

Package: libudev1
Depends: libeudev1, ${misc:Depends}
Architecture: linux-any
Multi-Arch: same
Description: Transitional package for libeudev1
 This is a transitional package to ease upgrades to the libeudev1 package.
 It can safely be removed.

Package: libudev-dev
Depends: libeudev-dev, ${misc:Depends}
Architecture: linux-any
Multi-Arch: same
Description: Transitional package for libeudev-dev
 This is a transitional package to ease upgrades to the libeudev-dev package.
 It can safely be removed.

Package: udev-udeb
Build-Profiles: <!noudeb>
XC-Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: linux-any
Depends: eudev-udeb, ${misc:Depends}
Description: Transitional package for udev-udeb
 This is a transitional package to allow having eudev in debian-installer.

Package: libudev1-udeb
Build-Profiles: <!noudeb>
XC-Package-Type: udeb
Section: debian-installer
Priority: optional
Architecture: linux-any
Depends: libeudev1-udeb, ${misc:Depends}
Description: Transitional package for libeudev1-udeb
 This is a transitional package to allow having libeudev1 in debian-installer.

## udev 3.2.9+devuan4

=== debian/changelog ===
udev (1:3.2.9+devuan4) unstable; urgency=medium

  * Update native version to match eudev package 3.2.9-4.
  * README.md: Explain why the transitional packages are needed.
  * Add git tag 3.2.9.
  * debian/gbp.conf: Change to suites/unstable.
  * debian/compat: Upgrade to compat 10.
  * debian/copyright: Update Copyright years.
  * debian/control:
    - Add Origin: Devuan
    - Change maintainer to Devuan Dev Team <devuan-dev@lists.dyne.org>.
    - Add to udev, libudev1, libudev1: Section: oldlibs, Priority: optional,
      makes lintian happy.
    - Add myself to Uploaders.
    - Bump Standards-Version to 4.3.0.
    - Bump the debhelper build dependency to >= 10.
    - Fix typo in udev-udeb: udev-udeb -> eudev-udeb.

 -- Svante Signell <svante.signell@gmail.com>  Sun, 26 Jan 2020 11:35:54 +0100

udev (1:3.2.7+devuan1.1) unstable; urgency=medium

  * bumped version to superseed current package 

 -- Vincenzo (KatolaZ) Nicosia <katolaz@freaknet.org>  Fri, 16 Nov 2018 09:47:54 +0000

udev (1:3.2.7+devuan1) unstable; urgency=medium

  * bumped version to 1:3.2.7+devuan1

 -- Vincenzo (KatolaZ) Nicosia <katolaz@freaknet.org>  Thu, 08 Nov 2018 10:57:57 +0000

udev (1:3.2.5+devuan1) unstable; urgency=medium

  * bumped version to 1:3.2.5-1

 -- Vincenzo (KatolaZ) Nicosia <katolaz@freaknet.org>  Wed, 31 Oct 2018 04:35:09 +0000

=== debian/control ===
--- 
+++ 
@@ -1,17 +1,23 @@
 Source: udev
 Section: oldlibs
-Priority: extra
-Maintainer: Svante Signell <svante.signell@gmail.com>
-Uploaders: Ivan J. <parazyd@dyne.org>, Hleb Valoshka <375gnu@gmail.com>
-Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9)
+Priority: optional
+Maintainer: Devuan Dev Team <devuan-dev@lists.dyne.org>
+Uploaders: Ivan J. <parazyd@dyne.org>, 
+  Hleb Valoshka <375gnu@gmail.com>,
+  Vincenzo 'KatolaZ' Nicosia <katolaz@freaknet.org>,
+  Svante Signell <svante.signell@gmail.com>
+Standards-Version: 4.3.0
+Origin: Devuan
 Vcs-Git: https://git.devuan.org/devuan-packages/udev.git
 Vcs-Browser: https://git.devuan.org/devuan-packages/udev.git
+Build-Depends: debhelper (>= 10)
 
 Package: udev
-Depends: eudev, ${misc:Depends}
+Section: oldlibs
+Priority: optional
 Architecture: linux-any
 Multi-Arch: foreign
+Depends: eudev, ${misc:Depends}
 Description: Transitional package for eudev
  This is a transitional package to ease upgrades to the eudev package.
  It can safely be removed.
@@ -25,9 +31,11 @@
  It can safely be removed.
 
 Package: libudev-dev
-Depends: libeudev-dev, ${misc:Depends}
+Section: oldlibs
+Priority: optional
 Architecture: linux-any
 Multi-Arch: same
+Depends: libeudev-dev, ${misc:Depends}
 Description: Transitional package for libeudev-dev
  This is a transitional package to ease upgrades to the libeudev-dev package.
  It can safely be removed.
@@ -39,7 +47,7 @@
 Priority: optional
 Architecture: linux-any
 Depends: eudev-udeb, ${misc:Depends}
-Description: Transitional package for udev-udeb
+Description: Transitional package for eudev-udeb
  This is a transitional package to allow having eudev in debian-installer.
 
 Package: libudev1-udeb

## udev 079

=== extras/ata_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = ata_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL_PROGRAM}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(QUIET) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(QUIET) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIBSYSFS) $(LIB_OBJS)
ifneq ($(STRIPCMD),)
	$(QUIET) $(STRIPCMD) $@
endif

# man pages
%.8: %.xml
	xmlto man $?
.PRECIOUS: %.8

clean:
	rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	$(INSTALL_DATA) -D $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/edd_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = edd_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL_PROGRAM}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(QUIET) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(QUIET) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIBSYSFS) $(LIB_OBJS)
ifneq ($(strip $(STRIPCMD)),)
	$(QUIET) $(STRIPCMD) $@
endif

# man pages
%.8: %.xml
	xmlto man $?
.PRECIOUS: %.8

clean:
	rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	$(INSTALL_DATA) -D $(PROG).8 $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/$(PROG).8
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/floppy/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = create_floppy_devices
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL_PROGRAM}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(QUIET) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(QUIET) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIBSYSFS) $(LIB_OBJS)
ifneq ($(strip $(STRIPCMD)),)
	$(QUIET) $(STRIPCMD) $@
endif

# man pages
%.8: %.xml
	xmlto man $?
.PRECIOUS: %.8

clean:
	rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL_PROGRAM) -D $(PROG) $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(libudevdir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/scsi_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2003 IBM
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

SCSI_ID_VERSION = 0.9

PROG = scsi_id
OBJS= scsi_serial.o
HEADERS = scsi_id.h scsi.h scsi_id_version.h
GEN_HEADERS = scsi_id_version.h
MAN_PAGES = scsi_id.8

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL_PROGRAM}

# be able to run without udev
LIBSYSFS = -lsysfs
CROSS =
QUIET =
CC = $(CROSS)gcc
LD = $(CROSS)gcc
AR = $(CROSS)ar
STRIPCMD = $(CROSS)strip
CFLAGS += -Wall -pipe -fno-builtin -Wstrict-prototypes -Wsign-compare -D_GNU_SOURCE -D_FILE_OFFSET_BITS=64
LDFLAGS += -Wl

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(QUIET) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(QUIET) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIBSYSFS) $(LIB_OBJS)
ifneq ($(strip $(STRIPCMD)),)
	$(QUIET) $(STRIPCMD) $@
endif

scsi_id_version.h:
	@echo "/* This file is auto-generated by the Makefile */" > $@
	@echo \#define SCSI_ID_VERSION     \"$(SCSI_ID_VERSION)\" >> $@
	@echo \#define SCSI_ID_CONFIG_FILE     \"$(etcdir)/scsi_id.config\" >> $@

# man pages
%.8: %.xml
	xmlto man $?
.PRECIOUS: %.8

clean:
	rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	$(INSTALL_DATA) -D scsi_id.8 $(DESTDIR)$(mandir)/man8/scsi_id.8
.PHONY: uninstall-man

uninstall-man:
	-rm -f $(DESTDIR)$(mandir)/man8/scsi_id.8
.PHONY: uninstall-man

install-config:
	@if [ ! -r $(DESTDIR)$(etcdir)/scsi_id.config ]; then \
		echo $(INSTALL_DATA) -D ./scsi_id.config  $(DESTDIR)$(etcdir); \
		$(INSTALL_DATA) -D ./scsi_id.config $(DESTDIR)$(etcdir)/scsi_id.config; \
	fi
.PHONY: install-config

install: all install-bin install-config install-man
.PHONY: install

uninstall: uninstall-bin uninstall-man
.PHONY: uninstall

=== extras/usb_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

PROG = usb_id
OBJ =
HEADERS =
GEN_HEADERS =
MAN_PAGES =

prefix =
etcdir =	${prefix}/etc
sbindir =	${prefix}/sbin
usrbindir =	${prefix}/usr/bin
usrsbindir =	${prefix}/usr/sbin
libudevdir =	${prefix}/lib/udev
mandir =	${prefix}/usr/share/man
configdir =	${etcdir}/udev/

INSTALL = /usr/bin/install -c
INSTALL_PROGRAM = ${INSTALL}
INSTALL_DATA  = ${INSTALL} -m 644
INSTALL_SCRIPT = ${INSTALL_PROGRAM}

all: $(PROG) $(MAN_PAGES)
.PHONY: all
.DEFAULT: all

%.o: %.c $(GEN_HEADERS)
	$(QUIET) $(CC) -c $(CFLAGS) $< -o $@

$(PROG): %: $(HEADERS) %.o $(OBJS)
	$(QUIET) $(LD) $(LDFLAGS) $@.o $(OBJS) -o $@ $(LIBUDEV) $(LIBSYSFS) $(LIB_OBJS)
ifneq ($(strip $(STRIPCMD)),)
	$(QUIET) $(STRIPCMD) $@
endif

# man pages
%.8: %.xml
	xmlto man $?
.PRECIOUS: %.8

clean:
	rm -f $(PROG) $(OBJS) $(GEN_HEADERS)
.PHONY: clean

install-bin: all
	$(INSTALL_PROGRAM) $(PROG) $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: install-bin

uninstall-bin:
	- rm $(DESTDIR)$(sbindir)/$(PROG)
.PHONY: uninstall-bin

install-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

uninstall-man:
	@echo "Please create a man page for this tool."
.PHONY: uninstall-man

install-config:
	@echo "no config file to install"
.PHONY: install-config

=== extras/volume_id/libvolume_id/Makefile ===
# Makefile for udev extra invoked from the udev main Makefile
#
# Copyright (C) 2004-2005 Kay Sievers <kay.sievers@vrfy.org>
#
# Released under the GNU General Public License, version 2.
#

LIBVOLUME_ID = libvolume_id.a

OBJS=				\
	ext.o			\
	fat.o			\
	hfs.o			\
	highpoint.o		\
	isw_raid.o		\
	lsi_raid.o		\
	via_raid.o		\
	silicon_raid.o		\
	nvidia_raid.o		\
	promise_raid.o		\
	iso9660.o		\
	jfs.o			\
	linux_raid.o		\
	linux_swap.o		\
	lvm.o			\
	mac.o			\
	msdos.o			\
	ntfs.o			\
	reiserfs.o		\
	udf.o			\
	ufs.o			\
	xfs.o			\
	cramfs.o		\
	hpfs.o			\
	romfs.o			\
	sysv.o			\
	minix.o			\
	luks.o			\
	ocfs.o			\
	vxfs.o			\
	volume_id.o		\
	util.o

HEADERS=			\
	volume_id.h		\
	util.h

AR = $(CROSS)ar
RANLIB = $(CROSS)ranlib

all: $(LIBVOLUME_ID)
.PHONY: all
.DEFAULT: all

%.o: %.c
	$(QUIET) $(CC) -c $(CFLAGS) $< -o $@

$(LIBVOLUME_ID): $(HEADERS) $(OBJS)
	@rm -f $@
	$(QUIET) $(AR) cq $@ $(OBJS)
	$(QUIET) $(RANLIB) $@

clean:
	rm -f $(LIBVOLUME_ID) $(OBJS)
.PHONY: clean
